#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define FLOPPY_DEVICE "/dev/fd0"
char *prog;
char device[255] = FLOPPY_DEVICE;

void help() {
    fprintf(stderr,"Can't find floppy device %s! (maybe there's no floppy in the drive?)\n\n", device);
    fprintf(stderr,"Syntax: %s [path_to_floppy_device]\n", prog);
    fprintf(stderr,"Checks if an inserted floppy disk is write protected.\n");
    exit(-1);
}

int main(int argc, char *argv[]) {
    int fd;
    struct stat st;

    prog = argv[0];
    if (argc > 2)
    	help();
    if (argc == 2) {
	strncpy(device, argv[1], sizeof(device)-1);
	device[sizeof(device)-1] = '\0';
    }
    if (stat(device, &st) != 0)
        help();
    if ((fd = open(device, O_RDWR)) >= 0) {
	printf("Warning: Floppy disk in %s is not write protected!\n\007",device);
	close(fd);
	return 1;
    }
    return 0;
}
